//---------------------------------------------------------------------------

#include <vcl.h>
#include <vcl\registry.hpp>
#include <stdio.h>
#include <dir.h>
#include "md5.h"
#pragma hdrstop

#include "Server.h"
#include "About.h"
#include "Message.h"
#include "User.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TServerWnd *ServerWnd;
//---------------------------------------------------------------------------
__fastcall TServerWnd::TServerWnd(TComponent* Owner)
  : TForm(Owner)
{
  serverRunning = false;
}
//---------------------------------------------------------------------------
void __fastcall TServerWnd::MMAboutClick(TObject *Sender)
{
  AboutWnd->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::MMExitClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::MMStartClick(TObject *Sender)
{
  MMStart->Enabled = false;
  MMStop->Enabled = true;
  serverRunning = true;
  LRunning->Caption = "Running: started";
  MessageWnd->Add("Server started");
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::MMStopClick(TObject *Sender)
{
  MMStart->Enabled = true;
  MMStop->Enabled = false;
  serverRunning = false;
  LRunning->Caption = "Running: stopped";
  MessageWnd->Add("Server stopped");
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::MMViewMessagesClick(TObject *Sender)
{
  MessageWnd->Show();
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::FormShow(TObject *Sender)
{
  char buf[64];

  sprintf(buf, "IP Address: %s", "127.0.0.1");
  LAddress->Caption = buf;
  MessageWnd->Add("Server loaded");
}
//---------------------------------------------------------------------------


void __fastcall TServerWnd::MMAddClick(TObject *Sender)
{
  User *user;
  char buf[128];

  UserDlg->EUsername->Text = "";
  UserDlg->EPassword->Text = "";
  if ((UserDlg->ShowModal() == mrCancel) || (UserDlg->EUsername->Text == ""))
    return;
  user = new User;
  user->username = UserDlg->EUsername->Text;
  user->password = MD5(buf, UserDlg->EPassword->Text.c_str());
  UserList->Items->Add(user->username);
  users->Add(user);
  sprintf(buf, "User added: %s", user->username.c_str());
  MessageWnd->Add(buf);
  UpdateUsers();
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::UMAddClick(TObject *Sender)
{
  MMAddClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::FormCreate(TObject *Sender)
{
  FILE *fp;
  char str[256], buf[256], *c;
  User *user;
  int i, n;
  TRegistry *reg;

  users = new TList;

  getcwd(str, 256);
  sprintf(buf, "%s\\users.txt", str);
  fp = fopen(buf, "r");
  if (!fp)
    return;
  fgets(buf, 256, fp);
  sscanf(buf, "%i", &n);
  for(i = 0; i < n; i++)
  {
    fgets(buf, 256, fp);
    fgets(str, 256, fp);
    if ((feof(fp)) || (ferror(fp)))
      break;
    user = new User;
    if ((c = strchr(buf, '\n')) != 0)
      *c = 0;
    if ((c = strchr(str, '\n')) != 0)
      *c = 0;
    user->username = buf;
    user->password = str;
    users->Add(user);
    UserList->Items->Add(buf);
  }
  fclose(fp);
  UpdateUsers();

  reg = new TRegistry;
  reg->RootKey = HKEY_CURRENT_USER;
  reg->OpenKey("\\Software\\VSNI\\BigMouth Server", true);
  if (reg->ValueExists("LogMessages"))
    MMLogMessages->Checked = reg->ReadInteger("LogMessages");
  reg->CloseKey();
  delete reg;
}
//---------------------------------------------------------------------------


void __fastcall TServerWnd::MMEditClick(TObject *Sender)
{
  char buf[128];
  int i;

  i = UserList->ItemIndex;
  if (i == -1)
    return;
  UserDlg->EUsername->Text = ((User *)users->Items[i])->username;
  UserDlg->EPassword->Text = "********";
  UserDlg->EUsername->Modified = false;
  UserDlg->EPassword->Modified = false;
  if ((UserDlg->ShowModal() == mrCancel) ||
      (UserDlg->EUsername->Text == "") ||
      ((!UserDlg->EUsername->Modified) && (!UserDlg->EPassword->Modified)))
    return;
  sprintf(buf, "User modified: %s",
              ((User *)users->Items[i])->username.c_str());
  MessageWnd->Add(buf);
  UserList->Items->Strings[i] = UserDlg->EUsername->Text;
  ((User *)users->Items[i])->username = UserDlg->EUsername->Text;
  if (UserDlg->EPassword->Modified)
    ((User *)users->Items[i])->password =
                                MD5(buf, UserDlg->EPassword->Text.c_str());
  UpdateUsers();
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::MMDeleteClick(TObject *Sender)
{
  int i;
  char buf[128];

  i = UserList->ItemIndex;
  if (i == -1)
    return;
  sprintf(buf, "User deleted: %s",
                ((User *)users->Items[i])->username.c_str());
  MessageWnd->Add(buf);
  UserList->Items->Delete(i);
  users->Delete(i);
  users->Pack();
  UpdateUsers();
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::UMEditClick(TObject *Sender)
{
  MMEditClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::UMDeleteClick(TObject *Sender)
{
  MMDeleteClick(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TServerWnd::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  if (!serverRunning)
    return;
  if (Application->MessageBox("The server is running.\n\nExit anyway?",
        "BigMouth Server", MB_OKCANCEL + MB_ICONWARNING) == IDCANCEL)
    CanClose = false;
}
//---------------------------------------------------------------------------

void TServerWnd::UpdateUsers()
{
  char buf[64];

  UserList->Update();
  sprintf(buf, "Total users: %i", users->Count);
  LTotal->Caption = buf;
}

void __fastcall TServerWnd::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  FILE *fp;
  char str[256], buf[256];
  int i;
  TRegistry *reg;

  getcwd(str, 256);
  sprintf(buf, "%s\\users.txt", str);
  fp = fopen(buf, "w");
  fprintf(fp, "%i\n", users->Count);
  for(i = 0; i < users->Count; i++)
    fprintf(fp, "%s\n%s\n", ((User *)users->Items[i])->username.c_str(),
                            ((User *)users->Items[i])->password.c_str());
  fclose(fp);
  delete users;

  reg = new TRegistry;
  reg->RootKey = HKEY_CURRENT_USER;
  reg->OpenKey("\\Software\\VSNI\\BigMouth Server", true);
  reg->WriteInteger("LogMessages", MMLogMessages->Checked);
  reg->CloseKey();
  delete reg;

  MessageWnd->Add("Server unloaded");
}
//---------------------------------------------------------------------------

void __fastcall TServerWnd::MMLogMessagesClick(TObject *Sender)
{
  MMLogMessages->Checked = !MMLogMessages->Checked;
}
//---------------------------------------------------------------------------

